/* Credits/Copyright/Reference:
-Raw Javascript (DOM)-
	http://www.w3.org/TR/DOM-Level-2-Core/
		http://www.w3.org/TR/DOM-Level-2-Core/ecma-script-binding.html (quick reference of all JS DOM features)
	http://www.w3.org/TR/DOM-Level-2-Events/
		http://www.w3.org/TR/DOM-Level-2-Events/ecma-script-binding.html (JS Events Reference)
-Raw Javascript (language)-
	http://www.ecma-international.org/publications/standards/Ecma-262.htm
		http://www.ecma-international.org/publications/files/ECMA-ST/ECMA-262.pdf (direct link)


http://www.whatwg.org/specs/web-apps/current-work/
http://dev.w3.org/csswg/cssom/
*/

/* Credits/Copyright/Reference:
   List of applicable events:
SVG - http://www.w3.org/TR/2010/WD-SVG11-20100622/interact.html#SVGEvents
> focusin, focusout, activate, click, mousedown, mouseup, mouseover, mousemove, mouseout,
DOMSubtreeModified, DOMNodeInserted, DOMNodeRemoved, DOMNodeRemovedFromDocument, DOMNodeInsertedIntoDocument, DOMAttrModified, DOMCharacterDataModified,
SVGLoad, SVGUnload, SVGAbort, SVGError, SVGResize, SVGScroll, SVGZoom, beginEvent, endEvent, repeatEvent

HTML - http://www.whatwg.org/specs/web-apps/current-work/multipage/webappapis.html#event-handlers-on-elements,-document-objects,-and-window-objects
onchange, onclick, oncontextmenu, ondblclick, ondrag, ondragend, ondragenter, ondragleave, ondragover, ondragstart, ondrop
oninput, oninvalid, onkeydown, onkeypress, onkeyup, onmousedown, onmousemove, onmouseout, onmouseover, onmouseup, onmousewheel,
onscroll, onselect, onshow
onblur, onerror, onfocus, onload, 

DOM 3 Events - http://www.w3.org/TR/DOM-Level-3-Events/
blur, change, click, dblclick, DOMActivate, DOMAttributeNameChanged, DOMAttrModified, DOMCharacterDataModified,
DOMElementNameChanged, DOMFocusIn, DOMFocusOut, DOMNodeInserted, DOMNodeInsertedIntoDocument, DOMNodeRemoved, 
DOMNodeRemovedFromDocument, DOMSubtreeModified,
error, focus, focusin, focusout, keydown, keypress, keyup, load, mousedown, mouseenter, mouseleave, mousemove,
mouseoute, mouseover, mouseup, mousewheel, reset, resize, scroll, select, submit, textInput, unload, wheel

focusin,focusout,activate +svg-html

x - onchange, scroll, error
? - drag?

separate: contextmenu, select text

*/

/*
// prevent test from running more than 1 time!

// event, tests, results, 



*/

testdata = {
	"1": {
		"target":   "HTMLDivElement",
		"targetId": "test1_div2",
		"0": {"eventPhase":1, "currentTarget":getObjType(document),},
		"1": {"eventPhase":1, "currentTarget":"HTMLHtmlElement",},
		"2": {"eventPhase":1, "currentTarget":"HTMLBodyElement",},
		"3": {"eventPhase":1, "currentTarget":"HTMLDivElement",  "currentTargetId":"test1_div1",},
		"4": {"eventPhase":2, "currentTarget":"HTMLDivElement",  "currentTargetId":"test1_div2",},
		"5": {"eventPhase":2, "currentTarget":"HTMLDivElement",  "currentTargetId":"test1_div2",},
		"6": {"eventPhase":3, "currentTarget":"HTMLDivElement",  "currentTargetId":"test1_div1",},
		"7": {"eventPhase":3, "currentTarget":"HTMLBodyElement",},
		"8": {"eventPhase":3, "currentTarget":"HTMLHtmlElement",},
		"9": {"eventPhase":3, "currentTarget":getObjType(document),},
	},
	"2": {
		"target": "SVGRectElement",
		"targetId": "test2_rect",
		"0": {"eventPhase":1, "currentTarget":getObjType(document),},
		"1": {"eventPhase":1, "currentTarget":"HTMLHtmlElement",},
		"2": {"eventPhase":1, "currentTarget":"HTMLBodyElement",},
		"3": {"eventPhase":1, "currentTarget":"HTMLDivElement", "currentTargetId":"test2_div1",},
		"4": {"eventPhase":1, "currentTarget":"SVGSVGElement",  "currentTargetId":"test2_svg",},
		"5": {"eventPhase":1, "currentTarget":"SVGGElement",},
		"6": {"eventPhase":2, "currentTarget":"SVGRectElement", "currentTargetId":"test2_rect",},
		"7": {"eventPhase":2, "currentTarget":"SVGRectElement", "currentTargetId":"test2_rect",},
		"8": {"eventPhase":3, "currentTarget":"SVGGElement",},
		"9": {"eventPhase":3, "currentTarget":"SVGSVGElement",  "currentTargetId":"test2_svg",},
		"10":{"eventPhase":3, "currentTarget":"HTMLDivElement", "currentTargetId":"test2_div1",},
		"11":{"eventPhase":3, "currentTarget":"HTMLBodyElement",},
		"12":{"eventPhase":3, "currentTarget":"HTMLHtmlElement",},
		"13":{"eventPhase":3, "currentTarget":getObjType(document),},
	},
	"3": {
		"target":   "HTMLDivElement",
		"targetId": "test3_div2",
		"0": {"eventPhase":1, "currentTarget":getObjType(document),},
		"1": {"eventPhase":1, "currentTarget":"HTMLHtmlElement",},
		"2": {"eventPhase":1, "currentTarget":"HTMLBodyElement",},
		"3": {"eventPhase":1, "currentTarget":"HTMLDivElement", "currentTargetId":"test3_div1",},
		"4": {"eventPhase":2, "currentTarget":"HTMLDivElement", "currentTargetId":"test3_div2",},
		"5": {"eventPhase":2, "currentTarget":"HTMLDivElement", "currentTargetId":"test3_div2",},
		"6": {"eventPhase":3, "currentTarget":"HTMLDivElement", "currentTargetId":"test3_div1",},
		"7": {"eventPhase":3, "currentTarget":"HTMLBodyElement",},
		"8": {"eventPhase":3, "currentTarget":"HTMLHtmlElement",},
		"9": {"eventPhase":3, "currentTarget":getObjType(document),},
	},
	"4": {
		"target":   "HTMLDivElement",
		"targetId": "test4_div2",
		"0": {"eventPhase":1, "currentTarget":getObjType(document),},
		"1": {"eventPhase":1, "currentTarget":"HTMLHtmlElement",},
		"2": {"eventPhase":1, "currentTarget":"HTMLBodyElement",},
		"3": {"eventPhase":1, "currentTarget":"HTMLDivElement", "currentTargetId":"test4_div1",},
		"4": {"eventPhase":2, "currentTarget":"HTMLDivElement", "currentTargetId":"test4_div2",},
		"5": {"eventPhase":2, "currentTarget":"HTMLDivElement", "currentTargetId":"test4_div2",},
		"6": {"eventPhase":3, "currentTarget":"HTMLDivElement", "currentTargetId":"test4_div1",},
		"7": {"eventPhase":3, "currentTarget":"HTMLBodyElement",},
		"8": {"eventPhase":3, "currentTarget":"HTMLHtmlElement",},
		"9": {"eventPhase":3, "currentTarget":getObjType(document),},
	},
}

TESTS = {}
TestObj = function(type, testNo) {
	this.resultStr = ""	//init
	this.type = type
	this.testNo = testNo
	this.completed = false
	this.finish = function(phases) {
		this.phases = phases
		TestPanel.addResult(this.type, this.testNo, phases)
	}
	this.addResultStr = function(resultStr) {
		this.resultStr = resultStr
	}
}
TestsObj = function(type, testNos) {
	this.tests = []
	this.testNos = testNos
	for (key in this.testNos) {
		testNo = this.testNos[key]
		this.tests[testNo] = new TestObj(type, testNo)
	}

	this.started = false
	this.phases = []
	this.add = function(Event) {
		if(!isOfClass(Event.target,"non_target")) {
			if(this.started) {
				this.phases.push(new PhaseObj(Event))
				this.endCheck(Event)
			} else {
				this.phases = [new PhaseObj(Event)]
				this.started = true
			}
		}
	}

	this.endCheck = function(Event) {
		if (Event.eventPhase == 3 && this.phases[this.phases.length-1].currentTarget == getObjType(document)) {
			this.started = false

			// mark single test completed
			testNo = null
			for (key in this.phases) {
				tempNo = this.phases[key].getTestNo()
				if(tempNo) {
					testNo = tempNo
				}
			}
			if(testNo && this.tests[testNo]) {
				this.tests[testNo].finish(this.phases)
				this.tests[testNo].completed = true
			}

			// mark all completed??
			this.completedAll = true
			for (key in this.tests) {
				test = this.tests[key]
				if (!test.completed) {
					this.completedAll = false
				}
			}
		}
	}

	this.addResultStr = function(resultStr, testNo) {
		this.tests[testNo].addResultStr(resultStr)
	}
	this.getAllResults = function() {
		resultStr = ""
		for (testNo  in this.tests) {
			resultStr += this.tests[testNo].resultStr
		}
		return resultStr
	}

	// setup
	addEventToAll(document, type, function(Event){testResult(Event, type)}, "non_target")
}

function testResult(Event, type) { if(!TESTS[type].completedAll) {
	TESTS[type].add(Event)
}}


function setup() {
	noTests = function() {
		i = 1
		while(1) {
			if(!testdata[i]) {
				return i-1
			} else {
				i++
			}
		}
	}();
	TestPanel = new TestPanelClass(noTests)
	stardardTests = [1,2,3,4]
	TestPanel.addTest("click",stardardTests)		//
	TestPanel.addTest("mousedown",stardardTests)	//
	TestPanel.addTest("mouseup",stardardTests)	//
	TestPanel.addTest("mouseover",stardardTests)	//
							// check mouseover properties
	TestPanel.addTest("mousemove",stardardTests)	//
	TestPanel.addTest("mouseout",stardardTests)	//
							// check mousout properties
	TestPanel.addTest("dblclick",stardardTests)		//
	TestPanel.addTest("mousewheel",stardardTests)	//
//	TestPanel.addTest("blur",stardardTests)		//
//	TestPanel.addTest("focus",stardardTests)		//
}

TestPanelClass = function(noTests) {
	this.containerDiv = document.getElementById("test_results_panel")
	this.noTests = noTests
	labelDiv = '<div class="label">.</div>\n'
	for (var i=0; i<this.noTests; i++) {
		labelDiv += '\t<div class="test_entry">'+(i+1)+'</div>\n'
	}
	this.containerDiv.innerHTML += '<div class="row">\n'+labelDiv+'\n</div>\n'

	this.addTest = function(type, testNos) {
		testBoxes = '<div class="label">'+type+'</div>\n'
		for (var i=0; i<this.noTests; i++) {
			enabled = "disabled"
			for (key in testNos) {
				if(Number(testNos[key]) == Number(i)) {
					enabled = "enabled"
				}
			}
			id = "test_result_for_"+type+"_"+Number(i+1)
			testBoxes += '\t<div id="'+id+'" class="'+enabled+' test_entry">.</div>\n'
		}
		this.containerDiv.innerHTML += '<div class="row">\n'+testBoxes+'</div>\n'
		TESTS[type] = new TestsObj(type, testNos)
	}
	this.addResult = function(type, testNo, phases) {
		// test phases
		test = testPhases(type, testNo, phases)
		if (test.pass) {
			document.getElementById("test_result_for_"+type+"_"+testNo).style.backgroundColor = "green"
		} else {
			document.getElementById("test_result_for_"+type+"_"+testNo).style.backgroundColor = "red"
		}
		TESTS[type].addResultStr(test.resultStr, testNo)
		this._showAllResults()
	}
	this._showAllResults = function() {
		resultStr = ""
		for (type in TESTS) {
			resultStr += TESTS[type].getAllResults()
		}
		document.getElementById("result").value = resultStr
	}
}


function getObjType(obj) {
	//[object type] > "type"
	return (obj+"").slice("[object ".length,-1)
}
function getId(element) {
	if(getObjType(element) != getObjType(document) && element.hasAttribute("id")) { //document will give an error on .hasAttribute
		return element.getAttribute("id")
	} else {
		return null
	}
}
PhaseObj = function(Event) {
	// public //
	////////////
	this.getTestNo = function() {
		id = this.currentTargetId
		if(id && id.length > "test".length && id.slice(0,4) == "test") {	//what is the test number
			return Number(id.slice(4,5))
		} else {
			return null
		}
	}

	// setup //
	///////////
		// EventTarget = http://www.w3.org/TR/DOM-Level-2-Events/events.html#Events-EventTarget
		// eventPhase = from http://www.w3.org/TR/DOM-Level-2-Events/events.html#Events-Event
	this.target = getObjType(Event.target)
	this.targetId = getId(Event.target)
	this.eventPhase = Event.eventPhase
	this.currentTarget = getObjType(Event.currentTarget)
	this.currentTargetId = getId(Event.currentTarget)
	this.type = Event.type
}

function testPhases(type, testNo, phases) {
	// pass: ,resultStr: 
	pass = true
	resultStr = "Actual == Expected\n"
	resultStr += "type: "+	phases[0].type+"=="+type+"\n"
	resultStr += "target: "+phases[0].target+"["+phases[0].targetId+"]=="+testdata[testNo].target+"["+testdata[testNo].targetId+"]\n"
	for (phaseNo in phases) {
		phase = phases[phaseNo]
		test = testdata[testNo]
		if(test[phaseNo]) {		// check for blank/missing entries!!!!!!!!!!!!!!!!  check if same length!!!!!!!!!!
			testPhase = test[phaseNo]

			targetPass = (phase.target == test.target) ? true : false
			targetIdPass = (phase.targetId == test.targetId) ? true : false

			eventPhasePass = (phase.eventPhase == testPhase.eventPhase) ? true : false
			currentTargetPass = (phase.currentTarget == testPhase.currentTarget) ? true : false
			currentTargetIdPass = (phase.currentTargetId == testPhase.currentTargetId || (!phase.currentTargetId && !testPhase.currentTargetId)) ? true : false
			if(!pass || !targetPass || !targetIdPass || !eventPhasePass || !currentTargetPass || !currentTargetIdPass) {
				pass = false
			}
			resultStr += "eventPhase: "+phase.eventPhase+"=="+testPhase.eventPhase+"\tcurrentTarget: "+phase.currentTarget+"=="+testPhase.currentTarget+"\teventTarget: "+phase.target+"=="+test.target+"\n"
		} else {
			pass = false
		}
	}
	if(pass) {
		resultStr = "-------------------------\n"+resultStr
	} else {
		resultStr = "----------FAIL----------\n"+resultStr
	}
	return {"pass":pass, "resultStr":resultStr}
}











function isOfClass(element, className) {
	if(getObjType(element) != getObjType(document) && (element.nodeType == 1 || element.nodeType == 9)){ //document will give an error on .hasAttribute
		if(element.hasAttribute("class")) {
			if(element.getAttribute("class").indexOf(className) > -1) {
				return true
			}
		}
	}
	return false
}
addEventToAll = function(node, type, func, excludeClass) {
	// node = starting node
	// type = Event type
	// func = function to attach
	// excludeClass = class name to exclude from adding an event listener (self and its children)
	if(typeof(node) == typeof({}) && !isOfClass(node,excludeClass)) {
		if(node.nodeType == 1 || node.nodeType == 9) {
			node.addEventListener(type, func, true)
			node.addEventListener(type, func, false)
		}
		if(node.hasChildNodes) {
			for (key in node.childNodes) {
				childNode = node.childNodes[key]
				addEventToAll(childNode, type, func)
			}
		}
	}
}
